--[[

 Une simple fonction capable de supprimer les caractères magiques
 Un fonction pour les rendre invisible et une autre pour les faire reapparaitre
 Les caractères magiques sont des caractères utilise par le language dans la manipulation de texte. Si on le fait travailler avec ca directement, Ca coince!
 Basé (copié coller quoi :p) sur le travail de https://www.fhug.org.uk/wiki/doku.php?id=plugins:code_snippets:plain_text_substitution
 Fait par Galphoglas, mais totalement libre de droit! Modifier tant que vous voulez! Tout els droits sont ceux du propriétaire du site ci-dessus

 Exemple:
 
	txt="[Hello) - %world ?"
	
		plain (txt) >> %[Hello%) %- %%world %?
		
		Correction (txt) >> =#=Hello=#= =#= =#=world =#=
		
	Disparition(txt) >> =#CroO=Hello=#ParF= =#Moins= =#Pour=world =#Int=
	
	txt2= "=#CroO=Hello=#ParF= =#Moins= =#Pour=world =#Int="
	
	Apparition(txt2) >> [Hello) - %world ?
	
]]

--Variable de base

local strMagic = "([%^%$%(%)%%%.%[%]%*%+%-%?])"		-- UTF-8 replacement for "(%W)"




-- Version de base équivalent à "addslashes" en php
 
-- Hide magic pattern symbols	^ $ ( ) % . [ ] * + - ?
function plain(strTxt)
	-- Prefix every magic pattern character with a % escape character,
	-- where %% is the % escape, and %1 is the original character capture.
	strTxt = tostring(strTxt or ""):gsub(strMagic,"%%%1")
	return strTxt
end -- function plain




-- Version changeant completement la forme pour ne plus voir le carractère

function Correction(strTxt)
	strTxt = tostring(strTxt or ""):gsub(strMagic,"=#=") -- =#= random value :p
	return strTxt
end



-- Disparition et Apparition magiques...

function Disparition(strTxt)
	strTxt = tostring(strTxt or ""):gsub("%^","=#Chap="); -- On lui fait à l'envers ;)
	strTxt = tostring(strTxt or ""):gsub("%$","=#Dol=");
	strTxt = tostring(strTxt or ""):gsub("%(","=#ParO=");
	strTxt = tostring(strTxt or ""):gsub("%)","=#ParF=");
	strTxt = tostring(strTxt or ""):gsub("%%","=#Pour=");
	strTxt = tostring(strTxt or ""):gsub("%.","=#Point=");
	strTxt = tostring(strTxt or ""):gsub("%[","=#CroO=");
	strTxt = tostring(strTxt or ""):gsub("%]","=#CroF=");
	strTxt = tostring(strTxt or ""):gsub("%*","=#Aste=");
	strTxt = tostring(strTxt or ""):gsub("%+","=#Plus=");
	strTxt = tostring(strTxt or ""):gsub("%-","=#Moins=");
	strTxt = tostring(strTxt or ""):gsub("%?","=#Int=");
	
	return strTxt
end

function Apparition(strTxt)
	strTxt = tostring(strTxt or ""):gsub("=#Chap=","%^"); -- On lui fait à l'envers ce qui est déjà à l'envers ;)
	strTxt = tostring(strTxt or ""):gsub("=#Dol=","%$");
	strTxt = tostring(strTxt or ""):gsub("=#ParO=","%(");
	strTxt = tostring(strTxt or ""):gsub("=#ParF=","%)");
	strTxt = tostring(strTxt or ""):gsub("=#Pour=","%%");
	strTxt = tostring(strTxt or ""):gsub("=#Point=","%.");
	strTxt = tostring(strTxt or ""):gsub("=#CroO=","%[");
	strTxt = tostring(strTxt or ""):gsub("=#CroF=","%]");
	strTxt = tostring(strTxt or ""):gsub("=#Aste=","%*");
	strTxt = tostring(strTxt or ""):gsub("=#Plus=","%+");
	strTxt = tostring(strTxt or ""):gsub("=#Moins=","%-");
	strTxt = tostring(strTxt or ""):gsub("=#Int=","%?");
	
	return strTxt
end